<?php


/**
 * @file
 * Modal form für den Config String
 */

chdir("../..");
include './includes/variables.php';
require_once ('./includes/isgwtelnet.php');
include './misc/database.php';
$ba = new beroAri();
require_once ('./includes/lang.php');
require_once('/usr/local/www/berogui/includes/session.php');
include './misc/config_parameter.php';

//Config Felder, die nicht in dem Extra Config Feld reinkommen.
$config_values=array("t38", "dtmfmode", "codecs", "ec", "ectl", "dton", "oton", "screen", "pres", "bearer_cap", "cd", "ie_on_sip", "wait_for_cancel", 
	"from_sip_src_setting", "from_pstn_src_setting", "isdn_oad_setting", "isdn_oad2_setting", "isdn_qsigname_setting","isdn_redirected_nr_setting",
	"isdn_dad_setting", "analog_oad_setting","analog_display_setting", "sip_from_user_setting","sip_from_display_setting","s2i_cpt","i2s_cpt",
	"sip_to_user_setting","sip_national_code","sip_international_code", "isdn2sip_destination_numformat","dialplan_international_prefix",
	"sip2dialplan_dad_prefix_setting","dialplan2sip_oad_prefix_setting", "sip2dialplan_oad_prefix_setting","srtp_mode","srtp_crypto_suites");

?>


<script type="text/javascript" src="misc/script/more.js"></script>


<script type="text/javascript">
function showdef(){
	//Configuration für neue Parameter
	var conf=new Object();
	var config;
	<?php
	$e=hol_daten();
	echo "config='".trim($e[0]['config'])."';";
	echo "from='".trim($e[0]['fromDirection'])."';";
	echo "to='".trim($e[0]['toDirection'])."';";
	$conf=showconf($e);
	if ($conf!=NULL){
		foreach ($conf as $key => $value){
			echo "conf[\"".trim($key)."\"]=new Object();";
			foreach ($conf[$key] as $key1 => $value1){
				echo "conf[\"".trim($key)."\"][\"".trim($key1)."\"]=\"".trim($value1)."\";";
			}
		}
	}
	?>
	showdef_(conf,config,from,to)
;}

var validator = $("#config").validate({
        rules: {
            'srtp_crypto_suites[]': {
                required: {
                    depends: function() {
                        return (($("#srtp_mode").val() === "mandatory" || $("#srtp_mode").val() === "optional") && !$("#srtp_mode").is(":disabled"));
                    }
                }
            }           
        },
        highlight: function (element) {
            $(element).closest('.form-group').addClass('has-error');
        },
        unhighlight: function (element) {
            $(element).closest('.form-group').removeClass('has-error');
        }
    });
    
$( '#srtp_mode' ).change(function() {
    srtp();
    required();
});
function required() {
        if (($("#srtp_mode").val() === "mandatory" || $("#srtp_mode").val() === "optional") && !$("#srtp_mode").is(":disabled")) {
            addAsterisk("srtp_crypto_suites[]");
        } else {
            deleteAsterisk("srtp_crypto_suites[]");
        }
    }
	
	$( document ).ready(function() {
			hide_elements("<? echo $_GET['from'] . '-' . $_GET['to']; ?>"); 
			disable(); 
			showdef();
			$('[data-toggle="tooltip"]').tooltip({placement : 'auto bottom', html : true, trigger : 'hover', container: 'body'});
		});
		
	$('#more-tab a').on('hide.bs.tab', function (e) {
			var valid = true;
			var tab=e.target.getAttribute('href');
			$(tab).find("input").each(function() {
				if (!validator.element(this) && valid) {
					valid = false;
				}
			});
			$(tab).find("select").each(function() {
				if (!validator.element(this) && valid) {
					valid = false;
				}
			});
			if (!valid)
				e.preventDefault();
		});
		
	
</script>

<?php
$e=hol_daten();
$config=trim($e[0]['config']);

$page=$_GET['start'];
$dir=$_GET['dir'];
$search=$_GET['search'];

function pstnConfig($table,$letter,$lines,$e,$fromto,$ba){
	$conf=array();
	foreach ($lines as $line){
			if (stripos($line,'[')===0){
				preg_match("/\[(?<bez>.)\]\[(?<name>.+)\] (?<desc>.+) '(?<def>.*)'/",$line,$res);
				if ($res['bez']==$letter || $res['bez']=="p" || $res['bez'] == "*")
				$conf[$res['name']]=$res['def'];
			}

		}
		if (substr_count($e[0]['fromId'],"g:")==1){
			$query=$ba->select("SELECT config from $table WHERE gr='".substr($e[0][$fromto.'Id'], 2)."'");
			$config=sqlite_fetch_single($query);
			$configs=explode(',',$config);
			foreach ($configs as $value){
				$key=explode('=',$value,2);
				if ($key[0]!="") $conf[$key[0]]=$key[1];
			}
		}else{
			$query=$ba->select("SELECT config from $table WHERE port='".$e[0][$fromto.'Id']."'");
			$config=sqlite_fetch_single($query);
			$configs=explode(',',$config);
			foreach ($configs as $value){
				$key=explode('=',$value,2);
				if ($key[0]!="") $conf[$key[0]]=$key[1];
			}
		}
		return $conf;
}

function sipConfig($lines,$e,$fromto,$ba){
	$conf=array();
	foreach ($lines as $line){
			if (stripos($line,'[')===0){
				preg_match("/\[(?<bez>.)\]\[(?<name>.+)\] (?<desc>.+) '(?<def>.*)'/",$line,$res);
				if ($res['bez']=="s" || $res['bez'] == "*")
				$conf[$res['name']]=$res['def'];
			}

		}
		if (substr_count($e[0]['fromId'],"p:")==1 || substr_count($e[0]['fromId'],"d:")==1 || substr_count($e[0]['fromId'],"t:")==1 || substr_count($e[0]['fromId'],"a:")==1){
			$query=$ba->select("SELECT config from sip WHERE name='".substr($e[0][$fromto.'Id'], 2)."'");
			$config=sqlite_fetch_single($query);
			$configs=explode(',',$config);
			foreach ($configs as $value){
				$key=explode('=',$value,2);
				if ($key[0]!="") $conf[$key[0]]=$key[1];
			}
		}else{
			$query=$ba->select("SELECT config from sip WHERE name='".$e[0][$fromto.'Id']."'");
			$config=sqlite_fetch_single($query);
			$configs=explode(',',$config);
			foreach ($configs as $value){
				$key=explode('=',$value,2);
				if ($key[0]!="") $conf[$key[0]]=$key[1];
			}
		}
		return $conf;
}


function showconf($e){
	$isgw = new isgwtelnet();
	$result=$isgw->isgw_login();
	//$conf ist die Variable fürs Hash
	$conf=null;
	$ba=new beroAri();
	if ($result!=false){
	$dialplanc=$isgw->isgw_dialplanconfig();
	$lines=  explode("\n",$dialplanc);

	//ISDN Configuration FROM
	switch ($e[0]['fromDirection']){
		case "isdn":
			$conf['from']= pstnConfig('isdn', 'i', $lines, $e,"from",$ba);
			break;
		case "analog":
			$conf['from']= pstnConfig('analog', 'a', $lines, $e,"from",$ba);
			break;
		case "cas":
			$conf['from']= pstnConfig('cas_channels', 'c', $lines,$e,"from",$ba);
			break;
		case "gsm":
			$conf['from']= pstnConfig('gsm', 'g', $lines, $e,"from",$ba);
			break;
		case "lte":
			$conf['from']= pstnConfig('lte', 'l', $lines, $e,"from",$ba);
			break;
		case "sip":
			$conf['from']= sipConfig($lines, $e,"from",$ba);
			break;
	}
	switch ($e[0]['toDirection']){
		case "isdn":
			$conf['to']=  pstnConfig('isdn', 'i', $lines, $e,"to",$ba);
			break;
		case "analog":
			$conf['to']=  pstnConfig('analog', 'a', $lines, $e,"to",$ba);
			break;
		case "cas":
			$conf['to']=  pstnConfig('cas_channels', 'c', $lines, $e,"to",$ba);
			break;
		case "gsm":
			$conf['to']=  pstnConfig('gsm', 'g', $lines, $e,"to",$ba);
			break;
		case "lte":
			$conf['to']=  pstnConfig('lte', 'l', $lines, $e,"to",$ba);
			break;
		case "sip":
			$conf['to']= sipConfig($lines, $e,"to",$ba);
			break;
	}
	
	//Dialplan config
	if ($e[0]['config']!=""){
		$configs=explode(',',$e[0]['config']);
		foreach ($configs as $value){
			$key=explode('=',$value,2);
			if (($key[0]!="")) {
				if (array_key_exists($key[0],$conf['from'])) $conf['from'][$key[0]]=$key[1];
				elseif (array_key_exists($key[0],$conf['to'])) $conf['to'][$key[0]]=$key[1];
				else $conf['from'][$key[0]]=$key[1];
			}
		}
	}
//Wenn ISGW nicht gestartet ist
}else{
	//ISDN Configuration FROM
	switch ($e[0]['fromDirection']){
		case "isdn":
			$conf['from']= pstnConfig('isdn', 'i', array(), $e,"from",$ba);
			break;
		case "analog":
			$conf['from']= pstnConfig('analog', 'a', array(), $e,"from",$ba);
			break;
		case "cas":
			$conf['from']= pstnConfig('cas_channels', 'c', array(), $e,"from",$ba);
			break;
		case "gsm":
			$conf['from']= pstnConfig('gsm', 'g', array(), $e,"from",$ba);
			break;
		case "lte":
			$conf['from']= pstnConfig('lte', 'l', array(), $e,"from",$ba);
			break;
		case "sip":
			$conf['from']= sipConfig(array(), $e,"from",$ba);
			break;
	}
	switch ($e[0]['toDirection']){
		case "isdn":
			$conf['to']=  pstnConfig('isdn', 'i', array(), $e,"to",$ba);
			break;
		case "analog":
			$conf['to']=  pstnConfig('analog', 'a', array(), $e,"to",$ba);
			break;
		case "cas":
			$conf['to']=  pstnConfig('cas_channels', 'c', array(), $e,"to",$ba);
			break;
		case "gsm":
			$conf['to']=  pstnConfig('gsm', 'g', array(), $e,"to",$ba);
			break;
		case "lte":
			$conf['to']=  pstnConfig('lte', 'l', array(), $e,"to",$ba);
			break;
		case "sip":
			$conf['to']= sipConfig(array(), $e,"to",$ba);
			break;
	}

	if ($e[0]['config']!=""){
		$configs=explode(',',$e[0]['config']);
		foreach ($configs as $value){
			$key=explode('=',$value,2);
			if (($key[0]!="")) {
				if (array_key_exists($key[0],$conf['from'])) $conf['from'][$key[0]]=$key[1];
				elseif (array_key_exists($key[0],$conf['to'])) $conf['to'][$key[0]]=$key[1];
				else $conf['from'][$key[0]]=$key[1];
			}
		}
	}
}
return $conf;
}

function showdefmc($e){
	global $config_values;
	$isgw = new isgwtelnet();
	$result=$isgw->isgw_login();
	if ($result!=false){
		$dialplanc=$isgw->isgw_dialplanconfig();
		$lines=explode("\n",$dialplanc);
		foreach ($lines as $line){
			if (stripos($line,'[')===0){
				preg_match("/\[(?<bez>.+)\]\[(?<name>.+)\][\s]*(?<desc>.+)[\s]*\<(?<val>.*)\>[\s]*'(?<def>.*)'/",$line,$res);
				if (!in_array($res['name'],$config_values)){
					echo "<script>
						$('#extra_tooltip').html($('#extra_tooltip').html()+'<p>".DIALPLAN_OPTION_DIS."<b>&nbsp;".$res['name']."</b><br>".DIALPLAN_VALUES_DIS."<b>&nbsp;&lt;".$res['val']."&gt;</b><br>Default:<b>&nbsp;".$res['def']."</b><br><i>".htmlspecialchars ($res['desc'],ENT_QUOTES)."</i></p><br>');
					</script>";
				}
			}
		}

		$conf=showconf($e);
		if ($e[0]['config']!=""){
			$configs=explode(',',$e[0]['config']);
				foreach ($configs as $value){
				$key=explode('=',$value,2);
				if (($key[0]!="") && !in_array($key[0],$config_values)){
					echo "<script>
						if ($('#addit_options').html()=='')
							$('#addit_options').html('".trim($key[0])."=".trim($key[1])."');
						else
							$('#addit_options').html($('#addit_options').html()+'\\n".trim($key[0])."=".trim($key[1])."');</script>";
				}elseif (($key[0]!="") && ($key[1]=='') && !in_array($key[0],$config_values)){
					echo "<script>
						if ($('#addit_options').html()=='')
							$('#addit_options').html('".trim($key[0])."=');
						else
							$('#addit_options').html($('#addit_options').html()+'\\n".trim($key[0])."=');</script>";
				}
			}
		}
	}
}



function hol_daten(){
	$ba=new beroAri();
	if  (isset($_GET['dialplanid'])){
		$q=$ba->select("select * from dialplan where id='".sqlite_escape_string($_GET['dialplanid'])."'");
		$e=sqlite_fetch_all($q);
		return $e;

	}
}
?>
<!-- Tab buttons ISDN, SIP, ANALOG, ADITIONAL CONFIG -->
<ul class='nav nav-tabs' role='tablist' id='more-tab'>	    
	<? if ($e[0]['toDirection'] == "sip" || $e[0]['fromDirection'] == "sip" || ($e[0]['toDirection'] == "isdn" && $e[0]['fromDirection'] == "isdn")) { ?>
		<li role='presentation'><a href='#config_sip' aria-controls='SIP config string' role='tab' data-toggle='tab'>SIP</a></li>
	<?php
	}
	if ($e[0]['toDirection'] == "isdn" || $e[0]['fromDirection'] == "isdn") {
		?>
		<li role='presentation'><a href='#config_isdn' aria-controls='ISDN config string' role='tab' data-toggle='tab'>ISDN</a></li>
	<?php
	}
	if ($e[0]['toDirection'] == "analog" || $e[0]['fromDirection'] == "analog") {
		?>
		<li role='presentation'><a href='#config_analog' aria-controls='Analog config string' role='tab' data-toggle='tab'>Analog</a></li>
	<?php
	}
	if ($e[0]['toDirection'] == "analog") {
		if ((substr_count($e[0]['toId'], "g:") == 1)) {
			$q = $ba->select("select distinct port_type from analog where gr='" . substr($e[0]['toId'], 2) . "'");
			$portTypeTo = sqlite_fetch_single($q);
		} else {
			$q = $ba->select("select port_type from analog where port='" . $e[0]['toId'] . "'");
			$portTypeTo = sqlite_fetch_single($q);
		}
	}
	if ($e[0]['fromDirection'] == "analog") {
		if ((substr_count($e[0]['fromId'], "g:") == 1)) {
			$q = $ba->select("select distinct port_type from analog where gr='" . substr($e[0]['fromId'], 2) . "'");
			$portTypeFrom = sqlite_fetch_single($q);
		} else {
			$q = $ba->select("select port_type from analog where port='" . $e[0]['fromId'] . "'");
			$portTypeFrom = sqlite_fetch_single($q);
		}
	}


//Wenn eine Richtung der Direction FXS ist, wird das Dialplan Source Setting nicht angezeigt
	($portTypeFrom != "FXS" && $portTypeTo != "FXS") ? $showDialSrc = "" : $showDialSrc = "style='display:none'";

//Wenn eine Richtung der Direction FXO ist, wird das Caller ID Mapping nicht angezeigt
	($portTypeFrom != "FXO" && $portTypeTo != "FXO") ? $showCallerMapp = "" : $showCallerMapp = "style='display:none'";
	?>
	<li role='presentation' class='active'><a href='#config-string' aria-controls='config-string' role='tab' data-toggle='tab'>More</a></li>
</ul>

<div>
	<form action='modules/Dialplan/more_submit.php' id='config' method='POST' class='form-horizontal'>
		<div class='tab-content'>
			<div role='tabpanel' class='tab-pane active' id='config-string' style='padding-top:20px;'>
				<div class="row addit_options addit_options">
					<p class="lead text-center"><? echo DIALPLAN_CONFIGURATION_DIS; ?></p>
				</div>
				<div class='form-group addit_options'  data-toggle='tooltip' title='<? echo ADDIT_OPTIONS; ?>'>
					<label for='addit_options' class='col-sm-3 control-label'><? echo DIALPLAN_ADDITIONAL_CONFIG_DIS; ?></label>
					<div class='col-sm-8'>
						<textarea name='addit_options' id='addit_options' class='form-control' rows='5'></textarea>
					</div>
				</div>
				<div class='form-group addit_options'>
					<label for='extra_tooltip' class='col-sm-3 control-label'><? echo DIALPLAN_ADDITIONAL_CONFIG_DOC_DIS; ?></label>
					<div class='col-sm-8'>
						<p id='extra_tooltip' class='form-control-static' style='height: 170px; overflow: auto; border: 1px solid #A31D26; resize:both;'></p>
					</div>
				</div>
				<div class="clearfix"></div>
			</div>
			<? if ($e[0]['toDirection'] == "analog" || $e[0]['fromDirection'] == "analog") { ?>
				<div role='tabpanel' class='tab-pane' id='config_analog' style='padding-top:20px;'>
					<p class="lead text-center"><? echo DIALPLAN_CONFIGURATION_DIS; ?></p>
					<div class="row">
						<div class="col-lg-offset-10 col-lg-2 "><strong><? echo DIALPLAN_DEFAULT_DIS; ?></strong></div>
					</div>
					<? if ($e[0]['fromDirection'] != "isdn" && $e[0]['toDirection'] != "isdn") { ?>
						<div class='form-group ec' data-toggle='tooltip' title='<? echo EC; ?>'>
							<label for='ec' class='col-sm-3 control-label'><? echo DIALPLAN_EC_DIS; ?></label>
							<div class='col-sm-7'>
								<? echo ec('analog', $config); ?>
							</div>
							<div class='col-sm-1'>
								<input type='checkbox' value='1' name='def_ec' id='def_ec' checked 
									   onclick='if (def_ec.checked) $("#ec").prop("disabled", true); else $("#ec").prop("disabled", false);'>
							</div>
						</div>
						<div class='form-group analog' data-toggle='tooltip' title='<? echo EC_TAIL; ?>'>
							<label for='ec_tail' class='col-sm-3 control-label'><? echo DIALPLAN_EC_TAIL_LENGTH_DIS; ?></label>
							<div class='col-sm-7'>
								<? echo ec_tail('analog', $config); ?>
							</div>
							<div class='col-sm-1'>
								<input type='checkbox' value='1' name='def_ectl' id='def_ectl' checked  
									   onclick='if (def_ectl.checked) ectl.disabled = true; else ectl.disabled = false;'>
							</div>
						</div>
					<? } ?>

					<div class='form-group analog' data-toggle='tooltip' title='<? echo FROM_PSTN_SRC_SETTING; ?>' <? echo $showDialSrc; ?>>
						<label for='analog' class='col-sm-3 control-label'><? echo DIALPLAN_EC_TAIL_LENGTH_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo from_pstn_src_setting('analog', $e[0]['fromDirection'], $e[0]['toDirection'], $config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_from_pstn_src_setting_analog' id='def_from_pstn_src_setting_analog' checked 
								   onclick='if (def_from_pstn_src_setting_analog.checked) from_pstn_src_setting_analog.disabled = true; 
									   else from_pstn_src_setting_analog.disabled = false;'>

						</div>
					</div>
					<div class="row analog_oad_setting analog_display_setting" <? echo $showCallerMapp; ?>>
						<p class="lead text-center"><? echo DIALPLAN_CALLER_ID_MAPPING_DIS; ?></p>
					</div>
					<div class='form-group analog_oad_setting' <? echo $showCallerMapp; ?>>
						<label for='analog_oad_setting' class='col-sm-3 control-label'><? echo DIALPLAN_ANALOG_CLIP_SETTING_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo caller_id_mapping_pstn('analog_oad_setting', 'analog', $e[0]['fromDirection'], $e[0]['toDirection'], $config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_analog_oad_setting' id='def_analog_oad_setting' checked 
								   onclick='if (def_analog_oad_setting.checked) analog_oad_setting.disabled = true; else analog_oad_setting.disabled = false;'>

						</div>
					</div>
					<div class='form-group analog_display_setting' <? echo $showCallerMapp; ?>>
						<label for='analog_display_setting' class='col-sm-3 control-label'><? echo DIALPLAN_ANALOG_CNIP_SETTING_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo caller_id_mapping_pstn('analog_display_setting', 'analog', '', '', $config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_analog_display_setting' id='def_analog_display_setting' checked 
								   onclick='if (def_analog_display_setting.checked) analog_display_setting.disabled = true; 
									   else analog_display_setting.disabled = false;'>

						</div>
					</div>
				</div>
			<? } ?>
			<? if ($e[0]['toDirection'] == "isdn" || $e[0]['fromDirection'] == "isdn") { ?>
				<div role='tabpanel' class='tab-pane' id='config_isdn' style='padding-top:20px;'>
					<p class="lead text-center"><? echo DIALPLAN_CONFIGURATION_DIS; ?></p>
					<div class="row">
						<div class="col-lg-offset-10 col-lg-2 "><strong><? echo DIALPLAN_DEFAULT_DIS; ?></strong></div>
					</div>
					<div class='form-group isdn' data-toggle='tooltip' title='<? echo EC; ?>'>
						<!-- is name ec or analog? and afterwards, idem -->
						<label for='ec' class='col-sm-3 control-label'><? echo DIALPLAN_EC_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo ec('isdn', $config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_ec' id='def_ec' checked 
								   onclick='if (def_ec.checked) $("#ec").prop("disabled", true); else $("#ec").prop("disabled", false);'>
						</div>
					</div>
					<div class='form-group isdn' data-toggle='tooltip' title='<? echo EC_TAIL; ?>'>
						<label for='ec_tail' class='col-sm-3 control-label'><? echo DIALPLAN_EC_TAIL_LENGTH_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo ec_tail('isdn', $config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_ectl' id='def_ectl' checked  
								   onclick='if (def_ectl.checked) ectl.disabled = true; else ectl.disabled = false;'/>
						</div>
					</div>
					<div class='form-group dton' data-toggle='tooltip' title='<? echo DTON; ?>'>
						<label for='dton' class='col-sm-3 control-label'><? echo DIALPLAN_DTON_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo tons('dton', $config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_dton' id='def_dton' checked  
								   onclick='if (def_dton.checked) dton.disabled = true; else dton.disabled = false;'>
						</div>
					</div>
					<div class='form-group oton' data-toggle='tooltip' title='<? echo OTON; ?>'>
						<label for='oton' class='col-sm-3 control-label'><? echo DIALPLAN_OTON_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo tons('oton', $config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_oton' id='def_oton' checked  
								   onclick='if (def_oton.checked) oton.disabled = true; else oton.disabled = false;'>
						</div>
					</div>
					<div class='form-group screen' data-toggle='tooltip' title='<? echo SCREENING; ?>'>
						<label for='screen' class='col-sm-3 control-label'><? echo DIALPLAN_SCREENING_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo screen($config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_screen' id='def_screen' checked 
								   onclick='if (def_screen.checked) $("#screen").prop("disabled", true); else $("#screen").prop("disabled", false);'>
						</div>
					</div>
					<div class='form-group pres' data-toggle='tooltip' title='<? echo PRES; ?>'>
						<label for='pres' class='col-sm-3 control-label'><? echo DIALPLAN_PRESENTATION_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo pres($config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_pres' id='def_pres' checked 
								   onchange='if (def_pres.checked) $("#pres").prop("disabled", true); else $("#pres").prop("disabled", false);'/>

						</div>
					</div>
					<div class='form-group bearer_cap' data-toggle='tooltip' title='<? echo BEARER; ?>'>
						<label for='bearer_cap' class='col-sm-3 control-label'><? echo DIALPLAN_BEARER_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo bearer_cap($config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_bearer_cap' id='def_bearer_cap' checked 
								   onclick='if (def_bearer_cap.checked) bearer_cap.disabled = true; else bearer_cap.disabled = false;'>
						</div>
					</div>
					<div class='form-group cd' data-toggle='tooltip' title='<? echo CD; ?>'>
						<label for='cd' class='col-sm-3 control-label'><? echo DIALPLAN_CALL_DEFLECTION_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo cd($config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_cd' id='def_cd' checked 
								   onclick='if (def_cd.checked) $("#cd").prop("disabled", true); else $("#cd").prop("disabled", false);'>
						</div>
					</div>
					<div class='form-group from_pstn_src_setting' data-toggle='tooltip' title='<? echo FROM_PSTN_SRC_SETTING; ?>'>
						<label for='from_pstn_src_setting' class='col-sm-3 control-label'><? echo DIALPLAN_FROM_PSTN_SRC_SETTING_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo from_pstn_src_setting('isdn', $e[0]['fromDirection'], $e[0]['toDirection'], $config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_from_pstn_src_setting_isdn' id='def_from_pstn_src_setting_isdn' checked 
								   onclick='if (def_from_pstn_src_setting_isdn.checked) from_pstn_src_setting_isdn.disabled = true;
									   else from_pstn_src_setting_isdn.disabled = false;'>
						</div>
					</div>

					<div class="row isdn_oad_setting isdn_oad2_setting isdn_qsigname_setting isdn_redirected_nr_setting">
						<p class="lead text-center"><? echo DIALPLAN_CALLER_ID_MAPPING_DIS; ?></p>
					</div>
					<div class='form-group isdn_oad_setting' data-toggle='tooltip' title='<? echo ISDN_OAD_SETTING; ?>'>
						<label for='isdn_oad_setting' class='col-sm-3 control-label'><? echo DIALPLAN_ISDN_OAD_SETTING_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo caller_id_mapping_pstn('isdn_oad_setting', 'isdn', $e[0]['fromDirection'], $e[0]['toDirection'], $config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_isdn_oad_setting' id='def_isdn_oad_setting' checked 
								   onclick='if (def_isdn_oad_setting.checked) isdn_oad_setting.disabled = true; 
									   else isdn_oad_setting.disabled = false;'>
						</div>
					</div>
					<div class='form-group isdn_oad2_setting' data-toggle='tooltip' title='<? echo ISDN_OAD2_SETTING; ?>'>
						<label for='isdn_oad2_setting' class='col-sm-3 control-label'><? echo DIALPLAN_ISDN_OAD2_SETTING_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo caller_id_mapping_pstn('isdn_oad2_setting', 'isdn', '', '', $config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_isdn_oad2_setting' id='def_isdn_oad2_setting' checked 
								   onclick='if (def_isdn_oad2_setting.checked) isdn_oad2_setting.disabled = true; 
									   else isdn_oad2_setting.disabled = false;'/>
						</div>
					</div>
					<div class='form-group isdn_qsigname_setting' data-toggle='tooltip' title='<? echo ISDN_QSIGNAME_SETTING; ?>'>
						<label for='isdn_qsigname_setting' class='col-sm-3 control-label'><? echo DIALPLAN_ISDN_QSIGNAME_SETTING_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo caller_id_mapping_pstn('isdn_qsigname_setting', 'isdn', '', '', $config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_isdn_qsigname_setting' id='def_isdn_qsigname_setting' checked 
								   onclick='if (def_isdn_qsigname_setting.checked) isdn_qsigname_setting.disabled = true; 
									   else isdn_qsigname_setting.disabled = false;'/>
						</div>
					</div>
					<div class='form-group isdn_redirected_nr_setting' data-toggle='tooltip' 
						 title='<? echo ISDN_REDIRECTED_NR_SETTING; ?>'>
						<label for='isdn_redirected_nr_setting' class='col-sm-3 control-label'><? echo DIALPLAN_ISDN_REDIRECTED_NR_SETTING_DIS; ?></label>
						<div class='col-sm-7'>
							<? echo caller_id_mapping_pstn('isdn_redirected_nr_setting', 'isdn', '', '', $config); ?>
						</div>
						<div class='col-sm-1'>
							<input type='checkbox' value='1' name='def_isdn_redirected_nr_setting' id='def_isdn_redirected_nr_setting' 
								   checked onclick='if (def_isdn_redirected_nr_setting.checked) isdn_redirected_nr_setting.disabled = true; 
									   else isdn_redirected_nr_setting.disabled = false;'/>
						</div>
					</div>
				</div>
		<? } ?>
			
		<? if ($e[0]['toDirection'] == "sip" || $e[0]['fromDirection'] == "sip" || ($e[0]['toDirection'] == "isdn" && $e[0]['fromDirection'] == "isdn")) { ?>
			<div role='tabpanel' class='tab-pane' id='config_sip' style='padding-top:20px;'>
				<div class="row">
					<div class="col-lg-offset-10 col-lg-2 "><strong><? echo DIALPLAN_DEFAULT_DIS; ?></strong></div>
				</div>
				<div class="row t38 dtmfmode srtp_mode codecs">
					<p class="lead text-center"><? echo DIALPLAN_MEDIA_OPTIONS_DIS; ?></p>
				</div>
				<div class='form-group t38' data-toggle='tooltip' title='<? echo T38; ?>'>
					<label for='t38' class='col-sm-3 control-label'><? echo DIALPLAN_T38_SUPPORT_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo t38($config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_t38' id='def_t38' checked 
							   onclick='if (def_t38.checked) $("#t38").prop("disabled", true); else $("#t38").prop("disabled", false);'>
					</div>
				</div>
				<div class='form-group dtmfmode' data-toggle='tooltip' title='<? echo DTMFMODE; ?>'>
					<label for='dtmfmode' class='col-sm-3 control-label'><? echo DIALPLAN_DTMF_MODE_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo dtmfmode($config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' name='def_dtmfmode' id='def_dtmfmode' checked 
							   onclick='if (def_dtmfmode.checked) dtmfmode.disabled = true; else dtmfmode.disabled = false;'>
					</div>
				</div>
				<div class='form-group srtp_mode' data-toggle='tooltip' title='<? echo SRTP_MODE; ?>'>
					<label for='srtp_mode' class='col-sm-3 control-label'><? echo DIALPLAN_SRTP_MODE_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo srtp_mode($config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_srtp_mode' id='def_srtp_mode' checked 
							   onclick='if (def_srtp_mode.checked) $("#srtp_mode").prop("disabled",true); else $("#srtp_mode").prop("disabled",false);'>
					</div>
				</div>
				<div class='form-group srtp_crypto_suites'>
					<label for='srtp_crypto_suites[]' class='col-sm-3 control-label'><? echo DIALPLAN_SRTP_CRYPTO_SUITES_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo srtp_crypto_suites($config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_srtp_crypto_suites' id='def_srtp_crypto_suites' checked 
							   onclick='if (def_srtp_crypto_suites.checked) $("#srtp_crypto_suites").prop("disabled",true); 
								   else $("#srtp_crypto_suites").prop("disabled",false);'/>
					</div>
				</div>
				<div class='form-group codecs'>
					<label for='codecs' class='col-sm-3 control-label'><? echo DIALPLAN_CODECS_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo codecs($config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_codecs' id='def_codecs' data-toggle='tooltip' title='" . CODECS_DEF . "' checked
							   onclick='if (def_codecs.checked){
                                       $("#sel").prop("disabled", true);
                                       $("#sel1").prop("disabled", true);
                                       $("#upB").prop("disabled", true);
                                       $("#downB").prop("disabled", true);
                                       $("#addB").prop("disabled", true);
                                       $("#removeB").prop("disabled", true);
                                    } else{
                                       $("#sel").prop("disabled", false);
                                       $("#sel1").prop("disabled", false);
                                       $("#upB").prop("disabled", false);
                                       $("#downB").prop("disabled", false);
                                       $("#addB").prop("disabled", false);
                                       $("#removeB").prop("disabled", false);
                                    }'>

					</div>
				</div>
				
				<div class="clearfix"></div>
				<div class="row wait_for_cancel s2i_cpt i2s_cpt ">
					<p class="lead text-center"><? echo DIALPLAN_STATE_OPTIONS_DIS; ?></p>
				</div>
				<div class='form-group wait_for_cancel ' data-toggle='tooltip' title='<? echo WAIT_FOR_CANCEL; ?>'>
					<label for='wait_for_cancel' class='col-sm-3 control-label'><? echo DIALPLAN_WAIT_FOR_CANCEL_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo wait_for_cancel($config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_wait_for_cancel' id='def_wait_for_cancel' checked 
							   onclick='if (def_wait_for_cancel.checked) $("#wait_for_cancel").prop("disabled", true); 
							   else $("#wait_for_cancel").prop("disabled", false);'>
					</div>
				</div>
				<div class='form-group s2i_cpt ' data-toggle='tooltip' title='<? echo CALL_PROGRESS_TABLE; ?>'>
					<label for='s2i_cpt' class='col-sm-3 control-label'><? echo DIALPLAN_CALL_PROGRESS_TABLE_S2I_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo s2i_cpt($config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_s2i_cpt' id='def_s2i_cpt' checked 
							   onclick='if (def_s2i_cpt.checked) s2i_cpt.disabled = true; else s2i_cpt.disabled = false;'>
					</div>
				</div>
				<div class='form-group i2s_cpt ' data-toggle='tooltip' title='<? echo CALL_PROGRESS_TABLE; ?>'>
					<label for='i2s_cpt' class='col-sm-3 control-label'><? echo DIALPLAN_CALL_PROGRESS_TABLE_I2S_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo i2s_cpt($config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_i2s_cpt' id='def_i2s_cpt' checked 
							   onclick='if (def_i2s_cpt.checked) i2s_cpt.disabled = true; else i2s_cpt.disabled = false;'>	
					</div>
				</div>
				<div class="clearfix"></div>
				<div class="row ie_on_sip sip_to_user_setting sip_from_display_setting sip_from_user_setting ">
					<p class="lead text-center"><? echo DIALPLAN_SIP_SETTINGS_DIS; ?></p>
				</div>
				<div class='form-group ie_on_sip ' data-toggle='tooltip' title='<? echo IE_ON_SIP; ?>'>
					<label for='ie_on_sip' class='col-sm-3 control-label'><? echo DIALPLAN_IE_ON_SIP_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo ie_on_sip($config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_ie_on_sip' id='def_ie_on_sip' checked 
							   onclick='if (def_ie_on_sip.checked) $("#ie_on_sip").prop("disabled", true); else $("#ie_on_sip").prop("disabled", false);'>
					</div>
				</div>
				<div class='form-group sip_to_user_setting ' data-toggle='tooltip' title='<? echo SIP_TO_USER_SETTING; ?>'>
					<label for='sip_to_user_setting' class='col-sm-3 control-label'><? echo DIALPLAN_SIP_TO_USER_SETTING_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo called_party_number_sip('sip_to_user_setting', $config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_sip_to_user_setting' id='def_sip_to_user_setting' checked 
							   onclick='if (def_sip_to_user_setting.checked) sip_to_user_setting.disabled = true; else sip_to_user_setting.disabled = false;'>
					</div>
				</div>
				<div class='form-group sip_from_user_setting ' data-toggle='tooltip' title='<? echo SIP_FROM_USER_SETTING; ?>'>
					<label for='sip_from_user_setting' class='col-sm-3 control-label'><? echo DIALPLAN_SIP_FROM_USER_SETTING_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo caller_id_mapping_sip('sip_from_user_setting', $config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_sip_from_user_setting' id='def_sip_from_user_setting' checked 
							   onclick='if (def_sip_from_user_setting.checked) sip_from_user_setting.disabled=true; else sip_from_user_setting.disabled=false;'>
					</div>
				</div>
				<div class='form-group sip_from_display_setting ' data-toggle='tooltip' title='<? echo SIP_FROM_DISPLAY_SETTING; ?>'>
					<label for='sip_from_display_setting' class='col-sm-3 control-label'><? echo DIALPLAN_SIP_FROM_DISPLAY_SETTING_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo caller_id_mapping_sip('sip_from_display_setting', $config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_sip_from_display_setting' id='def_sip_from_display_setting' checked 
							   onclick='if (def_sip_from_display_setting.checked) sip_from_display_setting.disabled=true; 
							   else sip_from_display_setting.disabled=false;'/>
					</div>
				</div>
				<div class="clearfix"></div>
				<div class="row sip_national_code sip_international_code dialplan_international_prefix 
					 isdn2sip_destination_numformat dialplan2sip_oad_prefix_setting sip2dialplan_dad_prefix_setting
					 sip2dialplan_oad_prefix_setting ">
					<p class="lead text-center"><? echo DIALPLAN_PROVIDER_SETTINGS_DIS; ?></p>
				</div>
				<div class='form-group sip_national_code ' data-toggle='tooltip' title='<? echo SIP_NATIONAL_CODE_SETTING; ?>'>
					<label for='sip_national_code' class='col-sm-3 control-label'><? echo DIALPLAN_SIP_NATIONAL_CODE_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo sip_input_text('sip_national_code', $config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_sip_national_code' id='def_sip_national_code' checked 
							   onclick='if (def_sip_national_code.checked) sip_national_code.disabled=true; else sip_national_code.disabled=false;'>
					</div>
				</div>
				<div class='form-group sip_international_code ' data-toggle='tooltip' title='<? echo SIP_INTERNATIONAL_CODE_SETTING; ?>'>
					<label for='sip_international_code' class='col-sm-3 control-label'><? echo DIALPLAN_SIP_INTERNATIONAL_CODE_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo sip_input_text('sip_international_code', $config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_sip_international_code' id='def_sip_international_code' checked 
							   onclick='if (def_sip_international_code.checked) sip_international_code.disabled=true; else sip_international_code.disabled=false;'>
					</div>
				</div>
				<div class='form-group dialplan_international_prefix '>
					<label for='dialplan_international_prefix' class='col-sm-3 control-label'><? echo DIALPLAN_DIALPLAN_INTERNATIONAL_PREFIX_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo sip_input_text('dialplan_international_prefix', $config, "00"); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_dialplan_international_prefix' id='def_dialplan_international_prefix' checked 
							   onclick='if (def_dialplan_international_prefix.checked) dialplan_international_prefix.disabled=true; 
							   else dialplan_international_prefix.disabled=false;'>
					</div>
				</div>
				<div class="clearfix"></div>
				<div class="row isdn2sip_destination_numformat dialplan2sip_oad_prefix_setting ">
					<div class="text-center">
						<h5><? echo DIALPLAN_PSTN_TO_SIP_DIS; ?></h5>
					</div>
				</div>
				<div class='form-group isdn2sip_destination_numformat ' data-toggle='tooltip' title='<? echo ISDN2SIP_DESTINATION_NUMFORMAT; ?>'>
					<label for='isdn2sip_destination_numformat' class='col-sm-3 control-label'><? echo DIALPLAN_ISDN2SIP_DESTINATION_NUMFORMAT_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo isdn2sip_destination_numformat($config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_isdn2sip_destination_numformat' id='def_isdn2sip_destination_numformat' checked 
							   onclick='if (def_isdn2sip_destination_numformat.checked) isdn2sip_destination_numformat.disabled=true; 
							   else isdn2sip_destination_numformat.disabled=false;'>
					</div>
				</div>
				<div class='form-group dialplan2sip_oad_prefix_setting '>
					<label for='dialplan2sip_oad_prefix_setting' class='col-sm-3 control-label'><? echo DIALPLAN_DIALPLAN2SIP_OAD_PREFIX_SETTING_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo dialplan2sip_oad_prefix_setting($config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_dialplan2sip_oad_prefix_setting' id='def_dialplan2sip_oad_prefix_setting' checked 
							   onclick='if (def_dialplan2sip_oad_prefix_setting.checked) $("#dialplan2sip_oad_prefix_setting").prop("disabled",true); 
							   else $("#dialplan2sip_oad_prefix_setting").prop("disabled",false);'/>
					</div>
				</div>
				<div class="clearfix"></div>
				<div class="row sip2dialplan_dad_prefix_setting sip2dialplan_oad_prefix_setting ">
					<div class="text-center">
						<h5><? echo DIALPLAN_SIP_TO_PSTN_DIS; ?></h5>
					</div>
				</div>
				<div class='form-group sip2dialplan_dad_prefix_setting '>
					<label for='sip2dialplan_dad_prefix_setting' class='col-sm-3 control-label'><? echo DIALPLAN_SIP2DIALPLAN_DAD_PREFIX_SETTING_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo sip2dialplan_dad_prefix_setting($config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_sip2dialplan_dad_prefix_setting' id='def_sip2dialplan_dad_prefix_setting' checked 
							   onclick='if (def_sip2dialplan_dad_prefix_setting.checked) $("#sip2dialplan_dad_prefix_setting").prop("disabled",true); 
							   else $("#sip2dialplan_dad_prefix_setting").prop("disabled",false);'>
					</div>
				</div>
				<div class='form-group sip2dialplan_oad_prefix_setting '>
					<label for='sip2dialplan_oad_prefix_setting' class='col-sm-3 control-label'><? echo DIALPLAN_SIP2DIALPLAN_OAD_PREFIX_SETTING_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo sip2dialplan_oad_prefix_setting($config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_sip2dialplan_oad_prefix_setting' id='def_sip2dialplan_oad_prefix_setting' checked 
							   onclick='if (def_sip2dialplan_oad_prefix_setting.checked) $("#sip2dialplan_oad_prefix_setting").prop("disabled",true); 
							   else $("#sip2dialplan_oad_prefix_setting").prop("disabled",false);'/>
					</div>
				</div>
				<div class="clearfix"></div>
				<div class="row from_sip_src_setting ">
					<p class="lead text-center"><? echo DIALPLAN_OPTIONS_DIS; ?></p>
				</div>
				<div class='form-group from_sip_src_setting ' data-toggle='tooltip' title='<? echo FROM_SIP_SRC_SETTING; ?>'>
					<label for='failover_timeout' class='col-sm-3 control-label'><? echo DIALPLAN_FROM_SIP_SRC_SETTING_DIS; ?></label>
					<div class='col-sm-7'>
					<? echo from_sip_src_setting($config); ?>
					</div>
					<div class='col-sm-1'>
						<input type='checkbox' value='1' name='def_from_sip_src_setting' id='def_from_sip_src_setting' checked 
							   onclick='if (def_from_sip_src_setting.checked) from_sip_src_setting.disabled=true; else from_sip_src_setting.disabled=false;'/>
					</div>
				</div>
				<div class="clearfix"></div>
			</div>
		<? } ?>
		</div>
		<br/> 
		<input name='page' type='hidden' value='<? echo $page; ?>'>
		<input name='dir' type='hidden' value='<? echo $dir; ?>'>
		<input name='search' type='hidden' value='<? echo $search; ?>'>
		<input name='id_upd' type='hidden' value='<? echo $_GET['dialplanid']; ?>'>
		<input name='from' type='hidden' value='<? echo $e[0]['fromDirection']; ?>'>
		<input name='to' type='hidden' value='<? echo $e[0]['toDirection']; ?>'>
 
  <? if ($_GET['isdnid']!=""){ ?>
  <input name='isdnid' type='hidden' value='<? echo $_GET['isdnid']; ?>'>
		<? } ?>

		<div id='buttons' class='text-center'><input name='submit' class='btn btn-default' type='submit' value='<? echo BUTTON_SAVE; ?>' onclick='selectall();' data-toggle='tooltip' title='<? echo DIALPLAN_SAVE; ?>'>
		</div>
		</form>
</div>
<?	showdefmc($e); ?>


